#include "p18f26k22.h"

#define OSCILLATEUR_INTERNE
// voir Help
//  Topics
//        Pic18
//            config bits settings
//                    choisir PIC18F26K22
#ifdef OSCILLATEUR_INTERNE
#pragma config FOSC = INTIO67, FCMEN = OFF, PLLCFG=OFF            // CONFIG1H
#else
#pragma config FOSC = HSMP, PLLCFG=ON, PRICLKEN=ON ,FCMEN=OFF      // quartz 10Mhz
#endif
#pragma config IESO=OFF,PWRTEN=OFF,BOREN=OFF,WDTEN=OFF,CCP2MX=PORTC1
#pragma config PBADEN=OFF,T3CMX=PORTC0,P2BMX=PORTC0,CCP3MX=PORTB5
#pragma config MCLRE=EXTMCLR,STVREN=OFF,LVP=ON,XINST=OFF,DEBUG=OFF
#pragma config CP0 = OFF, CP1 = OFF, CP2 = OFF, CP3 = OFF                    // CONFIG5Lhello
#pragma config CPB = OFF, CPD = OFF                                          // CONFIG5H
#pragma config WRT0 = OFF, WRT1 = OFF, WRT2 = OFF, WRT3 = OFF                // CONFIG6L
#pragma config WRTB = OFF, WRTC = OFF, WRTD = OFF                            // CONFIG6H
#pragma config EBTR0 = OFF, EBTR1 = OFF, EBTR2 = OFF, EBTR3 = OFF            // CONFIG7L
#pragma config EBTRB = OFF                                                   // CONFIG7H

#include <p18cxxx.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <i2c.h>

#include <delays.h>
#include <usart.h>

#include "../_common/Uart1.h"
#include "../_common/I2C_RTC_DS1307.h"
#include "../_common/RTC_DS1307.h"
#include "../_common/I2C_RTC_DS1307.h"
#include "../_common/RTC_DS1307.h"

/*
Uart1.h
void Init_UART1(void);
void Put_RS( unsigned char  untel);
void PutStr_RS( unsigned char *s);
void PutStrR_RS(const rom  char *s);
void PutR_RS( const rom  char * untel);
void CRLF(void);
void Tempo(long L);
------------
RTC_DS1307.h"
unsigned char sec, min, hr, week_day, day, mn, year;
void readDS1307(void);
void writeDS1307(void);
void Transform_Time_BCD_To_Binary(char s, char m, char hr, char wd, char d, char mo, char y);
----------------
Hardware
No Quartz ( FOSC interne 16MHz)
RC3 =SCL  avec R pull-up de 2,7K
RC4 =SDA  avec R pull-up de 2,7K
RC6 =TX   UART to Linvor BT to display result
RC7 =RX   UART to Linvor BT not used*/

#define Led_Rouge LATAbits.LATA4

#pragma udata

unsigned char  donnee,status;	
int i,j,k;
unsigned char sec, min, hr, week_day, day, mn, year;
unsigned char date,mth;




void main(void)
{
  ANSELA=0;
  TRISA=0b1101111;  // RA4 as output for led roouge
  Led_Rouge=1; // eteinte
  TRISB = 0xFF;
  PORTB = 0x00;
  ANSELC=0;       // <- pic18F26K22
  TRISC = 0b10011000;  // RC3,RC4 as Input RC7 as input  other => output
    
     #ifdef OSCILLATEUR_INTERNE  
// The internal oscillator is set to the default frequency of 1 MHz.
// The Internal Oscillator Frequency Select bits  (IRCF<2:0>)
// select the frequency output of the internal oscillator block  
   OSCCON=0b01110000;  //HFINTOSC  (16 MHz)
// OSCCONbits.IRCF2=1; //HFINTOSC  (16 MHz)
// OSCCONbits.IRCF1=1;
// OSCCONbits.IRCF0=1;
//111 = HFINTOSC       (16 MHz)
//110 = HFINTOSC/2     (8 MHz)
//101 = HFINTOSC/4     (4 MHz)
//100 = HFINTOSC/8     (2 MHz)
//011 = HFINTOSC/16    (1 MHz)(3)
    OSCTUNE=0;
    OSCTUNEbits.PLLEN=0;  // 1= avec PLL => 64Mhz    0 =sans PLL => 16Mhz 
    #endif   
    
   
    Init_UART1();
    PutR_RS( (const rom  char *)12); // CLS terminal display
    Tempo(300000L);
    PutStrR_RS((const rom unsigned char*)"\r\n Test DS1307  18F26K22 16MHz 15/12/2013  Mplab C18\r\n");

   OpenI2C1(MASTER,SLEW_OFF);
   Delay10KTCYx(250);
   
 // program get stuck without this  following line
   SSPADD = 39 ;    // at 16Mhz for I2C 100Khz;
   // SSPADD = 49 ; // at 20MHz for I2C 100Khz;
   // SSPADD = 24 ; // at 10Mhz for I2C 100Khz;
   StartI2C();
   IdleI2C();
   Delay10KTCYx(250);
   
   k=fprintf(_H_USART,(const rom char *)"\r\n Init UART1  19200bds\r\n "); 
   k=fprintf(_H_USART,(const rom char *)" Freq bus I2C=100Khz SSPADD= %02d \r\n  Init DS1307  :  31/12/2013 le 06 23H59M00S \r\n",SSPADD);
   sec=0x00;min=0x59;hr=0x23;week_day=6;
   day=0x31;mn=0x12;year=0x13;
   writeDS1307();
 
   // writeDS1307();  // init time en dur !

 while(1)
 {  day=0;mn=0;hr=0; sec=0;min=0;hr=0;week_day=0;year=0;
    k=fprintf(_H_USART,(const rom char*)"Lecture DS1307 avec fonctions Hardware I2C MPLAB"); 
    //store results into sec,min,hr,week_day,day,mn,year;
    readDS1307();
    Transform_Time_BCD_To_Binary( sec, min, hr, week_day, day, mn, year);
   	k=fprintf(_H_USART,(const rom char*)" DS1307 lecture time (en decimal)%02d/%02d/20%02d le %02d %02dH %02dM %02dS \n\r",day,mn,year,week_day,hr,min,sec);  
  /*  
   k=fprintf(_H_USART,(const rom unsigned char*)" Lecture DS1307 with other subroutines\n\r"); 
   ds1307_get_date();
   k=fprintf(_H_USART,(const rom unsigned char*)" DS1307 date %02d/%02d/20%02d/ le %2d \r\n",day,mn,year,week_day);
   ds1307_get_time();
   k=fprintf(_H_USART,(const rom unsigned char*)" DS1307 time %02dH%02dM%02dS \r\n",hr,min,sec);
 */
   Delay10KTCYx(250);
   Led_Rouge=!Led_Rouge;
 }
}

/* Avec seulement les fonctions bibliotheque I2C MPLAB
Lecture DS1307 avec fonctions Hardware I2C MPLAB 
 Freq bus I2C=100Khz DS1307 lecture time (en decimal)31/12/2013 le 06 23H 59M 04S 
Lecture DS1307 avec fonctions Hardware I2C MPLAB 
 Freq bus I2C=100Khz DS1307 lecture time (en decimal)31/12/2013 le 06 23H 59M 06S 
Lecture DS1307 avec fonctions Hardware I2C MPLAB 
 Freq bus I2C=100Khz DS1307 lecture time (en decimal)31/12/2013 le 06 23H 59M 07S 
Lecture DS1307 avec fonctions Hardware I2C MPLAB 
 Freq bus I2C=100Khz DS1307 lecture time (en decimal)31/12/2013 le 06 23H 59M 08S 
 DS1307 lecture time (en decimal)31/12/2013 le 06 23H 59M 56S 
Lecture DS1307 avec fonctions Hardware I2C MPLAB 
 Freq bus I2C=100Khz DS1307 lecture time (en decimal)31/12/2013 le 06 23H 59M 58S 
Lecture DS1307 avec fonctions Hardware I2C MPLAB 
 Freq bus I2C=100Khz DS1307 lecture time (en decimal)31/12/2013 le 06 23H 59M 59S 
Lecture DS1307 avec fonctions Hardware I2C MPLAB 
 Freq bus I2C=100Khz DS1307 lecture time (en decimal)01/01/2014 le 07 00H 00M 00S 
Lecture DS1307 avec fonctions Hardware I2C MPLAB 
 Freq bus I2C=100Khz DS1307 lecture time (en decimal)01/01/2014 le 07 00H 00M 02S 
Lecture DS1307 avec fonctions Hardware I2C MPLAB 

-----------------------

Test DS1307  18F26K22 16MHz 15/12/2013  Mplab C18

 Init UART1  19200bds
  Freq bus I2C=100Khz SSPADD= 39 
  Init DS1307  :  31/12/2013 le 06 23H59M00S 
Lecture DS1307 avec fonctions Hardware I2C MPLAB DS1307 lecture time (en decimal)31/12/2013 le 06 23H 59M 59S 
 Lecture DS1307 with other subroutines
 DS1307 date 31/12/2013/ le  6 
 DS1307 time 23H59M59S 
Lecture DS1307 avec fonctions Hardware I2C MPLAB DS1307 lecture time (en decimal)01/01/2014 le 07 00H 00M 01S 
 Lecture DS1307 with other subroutines
 DS1307 date 01/01/2014/ le  7 
 DS1307 time 00H00M01S 
Lecture DS1307 avec fonctions Hardware I2C MPLAB DS1307 lecture time (en decimal)01/01/2014 le 07 00H 00M 03S 
 Lecture DS1307 with other subroutines
 DS1307 date 01/01/2014/ le  7 
 DS1307 time 00H00M03S 
Lecture DS1307 avec fonctions Hardware I2C MPLAB DS1307 lecture time (en decimal)01/01/2014 le 07 00H 00M 05S 
 Lecture DS1307 with other subroutines
 DS1307 date 01/01/2014/ le  7 
 DS1307 time 00H00M05S 
Lecture DS1307 avec fonctions Hardware I2C MPLAB DS1307 lecture time (en decimal)01/01/2014 le 07 00H 00M 07S 
 Lecture DS1307 with other subroutines
 DS1307 date 01/01/2014/ le  7 
 DS1307 time 00H00M07S 
Lecture DS1307 avec fonctions Hardware I2C MPLAB DS1307 lecture time (en decimal)01/01/2014 le 07 00H 00M 09S 
 Lecture DS1307 with other subroutines
 DS1307 date 01/01/2014/ le  7 
 DS1307 time 00H00M09S 


----------------------------------------------------------------------
Release build of project `C:\_C18\_MesProjets_C18\_18F26K22_Test_DS1307\Test_DS1307.mcp' started.
Language tool versions: MPASMWIN.exe v5.47, mplink.exe v4.45, mcc18.exe v3.44, mplib.exe v4.45
Sun Dec 15 17:03:42 2013
----------------------------------------------------------------------
Clean: Deleting intermediary and output files.
Clean: Deleted file "C:\_C18\tmp\main.o".
Clean: Deleted file "C:\_C18\tmp\RTC_DS1307.o".
Clean: Deleted file "C:\_C18\tmp\Uart1.o".
Clean: Deleted file "C:\_C18\tmp\I2C_RTC_DS1307.o".
Clean: Deleted file "C:\_C18\_MesProjets_C18\_18F26K22_Test_DS1307\Test_DS1307.cof".
Clean: Deleted file "C:\_C18\_MesProjets_C18\_18F26K22_Test_DS1307\Test_DS1307.hex".
Clean: Done.
Executing: "C:\Program Files\Microchip\mplabc18\bin\mcc18.exe" -p=18F26K22 /i"C:\_C18\_MesProjets_C18\_common" -I"C:\_C18\_MesProjets_C18\_18F26K22_Test_DS1307\UART1" -I"C:\_C18\_MesProjets_C18\_18F26K22_Test_DS1307\RTCC" -I"C:\Program Files\Microchip\mplabc18\h" "main.c" -fo="C:\_C18\tmp\main.o" -k -Ou- -Ot- -Ob- -Op- -Or- -Od- -Opa-
C:\_C18\_MesProjets_C18\_18F26K22_Test_DS1307\main.c:114:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F26K22_Test_DS1307\main.c:115:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F26K22_Test_DS1307\main.c:124:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F26K22_Test_DS1307\main.c:130:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F26K22_Test_DS1307\main.c:134:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F26K22_Test_DS1307\main.c:136:Warning [2066] type qualifier mismatch in assignment
C:\_C18\_MesProjets_C18\_18F26K22_Test_DS1307\main.c:138:Warning [2066] type qualifier mismatch in assignment
Executing: "C:\Program Files\Microchip\mplabc18\bin\mcc18.exe" -p=18F26K22 /i"C:\_C18\_MesProjets_C18\_common" -I"C:\_C18\_MesProjets_C18\_18F26K22_Test_DS1307\UART1" -I"C:\_C18\_MesProjets_C18\_18F26K22_Test_DS1307\RTCC" -I"C:\Program Files\Microchip\mplabc18\h" "C:\_C18\_MesProjets_C18\_common\RTC_DS1307.c" -fo="C:\_C18\tmp\RTC_DS1307.o" -k -Ou- -Ot- -Ob- -Op- -Or- -Od- -Opa-
Executing: "C:\Program Files\Microchip\mplabc18\bin\mcc18.exe" -p=18F26K22 /i"C:\_C18\_MesProjets_C18\_common" -I"C:\_C18\_MesProjets_C18\_18F26K22_Test_DS1307\UART1" -I"C:\_C18\_MesProjets_C18\_18F26K22_Test_DS1307\RTCC" -I"C:\Program Files\Microchip\mplabc18\h" "C:\_C18\_MesProjets_C18\_common\Uart1.c" -fo="C:\_C18\tmp\Uart1.o" -k -Ou- -Ot- -Ob- -Op- -Or- -Od- -Opa-
C:\_C18\_MesProjets_C18\_common\Uart1.c:53:Warning [2054] suspicious pointer conversion
Executing: "C:\Program Files\Microchip\mplabc18\bin\mcc18.exe" -p=18F26K22 /i"C:\_C18\_MesProjets_C18\_common" -I"C:\_C18\_MesProjets_C18\_18F26K22_Test_DS1307\UART1" -I"C:\_C18\_MesProjets_C18\_18F26K22_Test_DS1307\RTCC" -I"C:\Program Files\Microchip\mplabc18\h" "C:\_C18\_MesProjets_C18\_common\I2C_RTC_DS1307.c" -fo="C:\_C18\tmp\I2C_RTC_DS1307.o" -k -Ou- -Ot- -Ob- -Op- -Or- -Od- -Opa-
Executing: "C:\Program Files\Microchip\mplabc18\bin\mplink.exe" /p18F26K22 /l"C:\Program Files\Microchip\mplabc18\lib" /k"C:\_C18\_MesProjets_C18\_18F26K22_Test_DS1307" "18f26k22.lkr" "..\..\tmp\main.o" "..\..\tmp\RTC_DS1307.o" "..\..\tmp\Uart1.o" "..\..\tmp\I2C_RTC_DS1307.o" /u_CRUNTIME /o"C:\_C18\_MesProjets_C18\_18F26K22_Test_DS1307\Test_DS1307.cof" /M"C:\_C18\_MesProjets_C18\_18F26K22_Test_DS1307\Test_DS1307.map" /W
MPLINK 4.45, Linker
Device Database Version 1.10
Copyright (c) 1998-2011 Microchip Technology Inc.
Errors    : 0

MP2HEX 4.45, COFF to HEX File Converter
Copyright (c) 1998-2011 Microchip Technology Inc.
Errors    : 0

Loaded C:\_C18\_MesProjets_C18\_18F26K22_Test_DS1307\Test_DS1307.cof.
----------------------------------------------------------------------
Release build of project `C:\_C18\_MesProjets_C18\_18F26K22_Test_DS1307\Test_DS1307.mcp' succeeded.
Language tool versions: MPASMWIN.exe v5.47, mplink.exe v4.45, mcc18.exe v3.44, mplib.exe v4.45
Sun Dec 15 17:03:46 2013
----------------------------------------------------------------------
BUILD SUCCEEDED
*/



